%% Explores solutions of the parameter fitting routine

function exploreE(Etot, r, ModName, X0, Data, varNames, paramNames);

    % Get the parameters in row r
    parMin = Etot(r, 2:end);
    errMin = Etot(r, 1);
    
    fprintf('\n\nThe error on place %i was:\t%f\n', r, errMin)
    
    % Time and data
    T = Data(:, 1); 
    X1 = Data(:, 2);

    params = parMin;
    
    % Solve with min parameters
    [ansT F1] = ode15s(@dAP, [T(1) T(end)], X0, [], params, ModName);
    
    
    for k=1:length(X0)
        try,
            close figure(k)
        end
        figure(k)
        clf('reset')
    end

    for k=1:length(X0)
        
        figure(k)
        hold off
        plot(ansT, F1(:,k), 'b', 'linewidth', 2)
        xlabel('Time', 'fontsize', 14)
        ylabel(varNames{k}, 'fontsize', 14)
        grid on
    end
    
    % Data, for now hardwired but should change in a future release
    figure(1)
    hold on
    plot(T, X1, 'ro', 'linewidth', 2)
    
    figure(length(X0)+1)
    for j=1:length(parMin)
        subplot(1, length(parMin), j)
        hold off
        hist(Etot(:, j+1))
        %hist(Stot(:, j+2));
        hold on
        plot(params(j), 0, 'r*')
        title(paramNames{j}, 'interpreter', 'Tex');
        xlabel('Parameter value')
        ylabel('Frequency')
    end
    