function thetaRand = getRandParams(prior, priorH)

    % pobability of keeping sampled params      
    p = 0.90;  
    N = size(priorH, 2);
  
    L = priorH(1, :); % Lower bound for H prior
    U = priorH(2, :); % Upper bound for H prior
    
    if prior == 0
        % No prior, get fresh random param
        params = ((U - L).*rand(1,N) + L)';
    else
        if size(prior, 1) == 1
            % No sampling needed, return vector as is
            params = prior';
        else
            % Sample from prior
            params = getRandParamsEmpirical(prior)';
        end
        
        % Change entries with probability 1-p to 
        % sample from Historical prior
        ranVec = rand(N,1);
        indChange = find(ranVec < 1-p);
        paramsUnif = ((U - L).*rand(1,N) + L)';
        if length(indChange > 0)
            params(indChange) = paramsUnif(indChange);
        end   
      
  end
  
  thetaRand = params;