% Objective function for Squeeze and Breathe
% Should work fairly straightforward, one 
% needs to make sure that the model (in ModName)
% can be called from here

function f = objFun(ModName, theta, X0, Data, numDec)
    try,
        % check that input values are (sufficiently) positive
        flag = min(theta) >= 0; 
        if flag == 0
            f = inf;
            return;
        else
            f = 0;
            
            % Time is first column of data matrix
            T = Data(:, 1);
            
            parTheta = theta;
            
            % get the time course for the parameters
            [ansT F1] = ode15s(@dAP, T, X0, [], parTheta, ModName);
         
            % distance form the data
            % This is particular to the example
            % In the future an indicator should say which
            % variables have data, for now it is hardcoded
            f = f + norm(Data(:,2) - F1(:,1));
            f = floor(10^numDec*f)/(10^numDec); % trucate decimals
        end
    catch,
        f = inf;
        fprintf('\n\n\t\t(ODE-CRASH)\n\n')
        % err = lasterror;
        % msg = err.message;
        % fprintf(msg)
        % s = err.stack(1,1);
        % fprintf(['\nAt: ' s.name '.m line: ' num2str(s.line) '\n'])
    end
    